import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

public class Game {
	
	static void outputGame(solver s)
	{
		FileWriter file;
		try {
			file = new FileWriter("game.out");	
			PrintWriter out = new PrintWriter(file);
			out.println(s.getCh());
			int i=0;
			while(i<s.getCh()*2)
			{
				out.println(s.getCoord()[i]+" "+s.getCoord()[i+1]);
				i=i+2;
			}

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	
	public static void main(String[] args) {
		matrix m1=new matrix("game.in");
		List<solver> listSolved=new ArrayList<solver>();
		
		for(int i=0; i<m1.getN(); i++){
			for(int j=0; j<m1.getN(); j++){
				if(Character.isDigit(m1.getMatr()[i][j].charAt(0))){
					listSolved.add(new solver(i,j,new matrix("game.in")));
					if(listSolved.get(listSolved.size()-1).getLeftDig()>0){
						listSolved.remove(listSolved.size()-1);
					}
				}
				if(!listSolved.isEmpty())if(listSolved.get(listSolved.size()-1).getBrLeft()==0) i=j=m1.getN();
			}
		}
		if(listSolved.get(listSolved.size()-1).getBrLeft()==0){
			outputGame(listSolved.get(listSolved.size()-1));
		}
		else{
			int k=3;
			while(k>0){
			for(int i=0; i<listSolved.size(); i++){
				if(listSolved.get(i).getBrLeft()>k){
					outputGame(listSolved.get(i));
					i=listSolved.size();
					k=0;
				}
			}
			k--;
			}
		}
	}

}
